#ifndef COMPARISON_BENCHMARKS_BASE_FFT_H
#define COMPARISON_BENCHMARKS_BASE_FFT_H

#include <complex>
#include <string>
#include <vector>

namespace comparison_benchmarks {
namespace base {
namespace fft {

const int SIZE = 8192;
const int NUM_ITERATIONS = 1000;
const int NUM_WARMUP_ITERATIONS = 100;

const int RECURSIVE_CUTOFF = 32;
typedef std::vector<std::complex<double>> complex_vector;

complex_vector generate_input();

void divide(complex_vector::iterator data, int n);
void conquer(complex_vector::iterator data, int n);
void combine(complex_vector::iterator data, int n);

}
}
}

#endif //COMPARISON_BENCHMARKS_BASE_FFT_H
